#include <stdlib.h>
#include <stdio.h>

#define MAX 1000

typedef struct node
{
  struct node *left;
  struct node *right;
  int value;
  int counter;
} node_t;

void track (node_t ** root, int x)
{
  if (!*root) {
    node_t * new_node = (node_t *) malloc (sizeof (node_t));
    new_node->value = x;
    new_node->left = NULL;
    new_node->right = NULL;
    new_node->counter = 0;

    *root = new_node;
    return;
  }

  if ((*root)->value > x) {
    (*root)->counter++;
    track (&(*root)->left, x);
  } else {
    track (&(*root)->right, x);
  }
}

int get_rank (node_t * root, int x, int count)
{
  if (!root)
    return -MAX;

  if (root->value > x)
    return get_rank (root->left, x, count);

  count = count + 1 + root->counter;
  if (root->value == x)
    return count;

  if (root->value < x)
    return get_rank (root->right, x, count);

  return -1;
}


int main()
{
  int size = 7000000;
  int i;
  int *stream = (int*)malloc(7000000*sizeof(int));
  for (i = 0; i < size; i++)
  {
	  stream[i] = i % 63000;
  }
	for (int i = 0; i < size; i++)
	{
		int *a = (int*)malloc(10 * sizeof(int));
		free(a);
	}
  node_t *tree = NULL;

  for (i = 0; i < size; i++) 
  {
  	track (&tree, stream[i]);
  }

  return 0;
}


/*OUTPUT

#include <stdlib.h>
#include <stdio.h>
//#include <pool.h>

#define MAX 1000

typedef struct node
{
  struct node *left;
  struct node *right;
  int value;
  int counter;
} node_t;

boost::pool<> pool1(sizeof (node_t));

void track (node_t ** root, int x)
{
  if (!*root) {
    node_t * new_node = (node_t *) pool.malloc();
    new_node->value = x;
    new_node->left = NULL;
    new_node->right = NULL;
    new_node->counter = 0;

    *root = new_node;
    return;
  }

  if ((*root)->value > x) {
    (*root)->counter++;
    track (&(*root)->left, x);
  } else {
    track (&(*root)->right, x);
  }
}

int get_rank (node_t * root, int x, int count)
{
  if (!root)
    return -MAX;

  if (root->value > x)
    return get_rank (root->left, x, count);

  count = count + 1 + root->counter;
  if (root->value == x)
    return count;

  if (root->value < x)
    return get_rank (root->right, x, count);

  return -1;
}


int main()
{
  int size = 7000000;
  int i;
  int *stream = (int*)malloc(7000000*sizeof(int));
  for (i = 0; i < size; i++)
  {
	  stream[i] = i % 63000;
  }
	for (int i = 0; i < size; i++)
	{
		int *a = (int*)malloc(10 * sizeof(int));
		free(a);
	}
  node_t *tree = NULL;

  for (i = 0; i < size; i++) 
  {
  	track (&tree, stream[i]);
  }

  return 0;
}


*/
